osg::Program::PerContextProgram Class Reference

`#include <Program>`

Inheritance diagram for osg::Program::PerContextProgram:

## Public Member Functions

| PerContextProgram (const Program *program, unsigned int contextID, GLuint programHandle=0)
GLuint | getHandle () const
const osg::Program * | getProgram () const
void | setDefineString (const std::string &defStr)
const std::string & | getDefineString () const
void | requestLink ()
virtual void | linkProgram (osg::State &state)
virtual bool | validateProgram ()
bool | needsLink () const
bool | isLinked () const
virtual bool | getInfoLog (std::string &infoLog) const
bool | loadedBinary () const
virtual ProgramBinary * | compileProgramBinary (osg::State &state)
virtual void | useProgram () const
void | resetAppliedUniforms () const
void | apply (const Uniform &uniform) const
const ActiveUniformMap & | getActiveUniforms () const
const ActiveVarInfoMap & | getActiveAttribs () const
const UniformBlockMap & | getUniformBlocks () const
GLint | getUniformLocation (unsigned int uniformNameID) const
GLint | getUniformLocation (const std::string &uniformName) const
GLint | getAttribLocation (const std::string &name) const
void | addShaderToAttach (Shader *shader)
void | addShaderToDetach (Shader *shader)
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Types

typedef std::pair< osg::ref_ptr< const osg::Uniform >, unsigned int > | UniformModifiedCountPair
typedef std::map< unsigned int, UniformModifiedCountPair > | LastAppliedUniformList
typedef std::vector< ref_ptr< Shader > > | ShaderList

## Protected Member Functions

virtual | ~PerContextProgram ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

const Program * | _program
osg::ref_ptr< GLExtensions > | _extensions
GLuint | _glProgramHandle
std::string | _defineStr
bool | _needsLink
bool | _isLinked
bool | _loadedBinary
const unsigned int | _contextID
bool | _ownsProgramHandle
ActiveUniformMap | _uniformInfoMap
ActiveVarInfoMap | _attribInfoMap
UniformBlockMap | _uniformBlockMap
LastAppliedUniformList | _lastAppliedUniformList
ShaderList | _shadersToDetach
ShaderList | _shadersToAttach
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

PerContextProgram (PCP) is an OSG-internal encapsulation of glPrograms per-GL context.

## Member Typedef Documentation

## LastAppliedUniformList

typedef std::map<unsigned int, UniformModifiedCountPair> osg::Program::PerContextProgram::LastAppliedUniformList

protected

## ShaderList

typedef std::vector< ref_ptr<Shader> > osg::Program::PerContextProgram::ShaderList

protected

## UniformModifiedCountPair

typedef std::pair<osg::ref_ptr<const osg::Uniform>, unsigned int> osg::Program::PerContextProgram::UniformModifiedCountPair

protected

## Constructor & Destructor Documentation

## PerContextProgram()

osg::Program::PerContextProgram::PerContextProgram | ( | const Program * | program,
|  | unsigned int | contextID,
|  | GLuint | programHandle = 0 )

Use "0" as programHandle to let the PeContextProgram execute "glCreateProgram"and "glDeleteProgram"

References osg::Program::Program().

## ~PerContextProgram()

virtual osg::Program::PerContextProgram::~PerContextProgram | ( |  | ) |

protected virtual

## Member Function Documentation

## addShaderToAttach()

void osg::Program::PerContextProgram::addShaderToAttach | ( | Shader * | shader | ) |

inline

References _shadersToAttach.

## addShaderToDetach()

void osg::Program::PerContextProgram::addShaderToDetach | ( | Shader * | shader | ) |

inline

References _shadersToDetach.

## apply()

void osg::Program::PerContextProgram::apply | ( | const Uniform & | uniform | ) | const

inline

References _extensions, _lastAppliedUniformList, osg::Uniform::apply(), osg::Uniform::getModifiedCount(), osg::Uniform::getNameID(), and getUniformLocation().

## compileProgramBinary()

virtual ProgramBinary * osg::Program::PerContextProgram::compileProgramBinary | ( | osg::State & | state | ) |

virtual

Compile a program binary. For this to work setProgramBinary must have been called on the osg::Program with an empty ProgramBinary prior to compileGLObjects being called. compileProgramBinary should be called after the program has been "exercised" by rendering with it. The ProgramBinary can then be saved to disk for faster subsequent compiling.

## getActiveAttribs()

const ActiveVarInfoMap & osg::Program::PerContextProgram::getActiveAttribs | ( |  | ) | const

inline

References _attribInfoMap.

## getActiveUniforms()

const ActiveUniformMap & osg::Program::PerContextProgram::getActiveUniforms | ( |  | ) | const

inline

References _uniformInfoMap.

## getAttribLocation()

GLint osg::Program::PerContextProgram::getAttribLocation | ( | const std::string & | name | ) | const

inline

References _attribInfoMap.

## getDefineString()

const std::string & osg::Program::PerContextProgram::getDefineString | ( |  | ) | const

inline

References _defineStr.

## getHandle()

GLuint osg::Program::PerContextProgram::getHandle | ( |  | ) | const

inline

References _glProgramHandle.

## getInfoLog()

virtual bool osg::Program::PerContextProgram::getInfoLog | ( | std::string & | infoLog | ) | const

virtual

## getProgram()

const osg::Program * osg::Program::PerContextProgram::getProgram | ( |  | ) | const

inline

References _program.

## getUniformBlocks()

const UniformBlockMap & osg::Program::PerContextProgram::getUniformBlocks | ( |  | ) | const

inline

References _uniformBlockMap.

## getUniformLocation() [1/2]

GLint osg::Program::PerContextProgram::getUniformLocation | ( | const std::string & | uniformName | ) | const

inline

Alternative version of getUniformLocation( unsigned int uniformNameID ) retrofited into OSG for backward compatibility with osgCal, after uniform ids were refactored from std::strings to GLints in OSG version 2.9.10.

Drawbacks: This method is not particularly fast. It has to access mutexed static map of uniform ids. So don't overuse it or your app performance will suffer.

References osg::Uniform::getNameID(), and getUniformLocation().

Referenced by getUniformLocation().

## getUniformLocation() [2/2]

GLint osg::Program::PerContextProgram::getUniformLocation | ( | unsigned int | uniformNameID | ) | const

inline

References _uniformInfoMap.

Referenced by apply().

## isLinked()

bool osg::Program::PerContextProgram::isLinked | ( |  | ) | const

inline

References _isLinked.

## linkProgram()

virtual void osg::Program::PerContextProgram::linkProgram | ( | osg::State & | state | ) |

virtual

## loadedBinary()

bool osg::Program::PerContextProgram::loadedBinary | ( |  | ) | const

inline

Was glProgramBinary called successfully?

References _loadedBinary.

## needsLink()

bool osg::Program::PerContextProgram::needsLink | ( |  | ) | const

inline

References _needsLink.

## requestLink()

void osg::Program::PerContextProgram::requestLink | ( |  | ) |

## resetAppliedUniforms()

void osg::Program::PerContextProgram::resetAppliedUniforms | ( |  | ) | const

inline

References _lastAppliedUniformList.

## setDefineString()

void osg::Program::PerContextProgram::setDefineString | ( | const std::string & | defStr | ) |

inline

References _defineStr.

## useProgram()

virtual void osg::Program::PerContextProgram::useProgram | ( |  | ) | const

virtual

## validateProgram()

virtual bool osg::Program::PerContextProgram::validateProgram | ( |  | ) |

virtual

## Member Data Documentation

## _attribInfoMap

ActiveVarInfoMap osg::Program::PerContextProgram::_attribInfoMap

protected

Referenced by getActiveAttribs(), and getAttribLocation().

## _contextID

const unsigned int osg::Program::PerContextProgram::_contextID

protected

## _defineStr

std::string osg::Program::PerContextProgram::_defineStr

protected

Define string passed on to Shaders to help configure them.

Referenced by getDefineString(), and setDefineString().

## _extensions

osg::ref_ptr<GLExtensions> osg::Program::PerContextProgram::_extensions

protected

Pointer to this context's extension functions

Referenced by apply().

## _glProgramHandle

GLuint osg::Program::PerContextProgram::_glProgramHandle

protected

Handle to the actual OpenGL glProgram

Referenced by getHandle().

## _isLinked

bool osg::Program::PerContextProgram::_isLinked

protected

Is our glProgram successfully linked?

Referenced by isLinked().

## _lastAppliedUniformList

LastAppliedUniformList osg::Program::PerContextProgram::_lastAppliedUniformList

mutable protected

Referenced by apply(), and resetAppliedUniforms().

## _loadedBinary

bool osg::Program::PerContextProgram::_loadedBinary

protected

Was glProgramBinary called successfully?

Referenced by loadedBinary().

## _needsLink

bool osg::Program::PerContextProgram::_needsLink

protected

Does our glProgram need to be linked?

Referenced by needsLink().

## _ownsProgramHandle

bool osg::Program::PerContextProgram::_ownsProgramHandle

protected

Does the glProgram handle belongs to this class?

## _program

const Program* osg::Program::PerContextProgram::_program

protected

Pointer to our parent Program

Referenced by getProgram().

## _shadersToAttach

ShaderList osg::Program::PerContextProgram::_shadersToAttach

protected

Referenced by addShaderToAttach().

## _shadersToDetach

ShaderList osg::Program::PerContextProgram::_shadersToDetach

protected

Referenced by addShaderToDetach().

## _uniformBlockMap

UniformBlockMap osg::Program::PerContextProgram::_uniformBlockMap

protected

Referenced by getUniformBlocks().

## _uniformInfoMap

ActiveUniformMap osg::Program::PerContextProgram::_uniformInfoMap

protected

Referenced by getActiveUniforms(), and getUniformLocation().

The documentation for this class was generated from the following file:

- osg/Program